ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.11 by greg, Thu Feb 24 20:14:26 2011 UTC vs.
Revision 2.42 by greg, Tue Apr 23 23:22:09 2013 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14 < my $td = `mktemp -d /tmp/genBSDF.XXXXXX`;
14 > my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16 < my $nsamp = 1000;
16 > my @savedARGV = @ARGV;
17 > my $tensortree = 0;
18 > my $ttlog2 = 4;
19 > my $nsamp = 2000;
20   my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24   my $doforw = 0;
25   my $doback = 1;
26 + my $pctcull = 90;
27 + my $gunit = "meter";
28   my @dim;
29   # Get options
30   while ($#ARGV >= 0) {
# Line 29 | Line 35 | while ($#ARGV >= 0) {
35                  shift @ARGV;
36          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37                  $geout = ("$ARGV[0]" =~ /^\+/);
38 +                $gunit = $ARGV[1];
39 +                if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 +                        die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 +                }
42 +                shift @ARGV;
43          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44                  $doforw = ("$ARGV[0]" =~ /^\+/);
45          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46                  $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51 +        } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52 +                $tensortree = substr($ARGV[0], 2, 1);
53 +                $ttlog2 = $ARGV[1];
54 +                shift @ARGV;
55          } elsif ("$ARGV[0]" eq "-c") {
56                  $nsamp = $ARGV[1];
57                  shift @ARGV;
# Line 51 | Line 70 | while ($#ARGV >= 0) {
70          shift @ARGV;
71   }
72   # Check that we're actually being asked to do something
73 < die "Must have at least one of +forward or +backward" if (!$doforw && !$doback);
73 > die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
74   # Get scene description and dimensions
75   my $radscn = "$td/device.rad";
76   my $mgfscn = "$td/device.mgf";
# Line 61 | Line 80 | if ( $mgfin ) {
80          die "Could not load MGF input\n" if ( $? );
81          system "mgf2rad $mgfscn > $radscn";
82   } else {
83 <        system "cat @ARGV | xform -e > $radscn";
83 >        system "xform -e @ARGV > $radscn";
84          die "Could not load Radiance input\n" if ( $? );
85          system "rad2mgf $radscn > $mgfscn" if ( $geout );
86   }
# Line 81 | Line 100 | close RADSCN;
100   # Generate octree
101   system "oconv -w $radscn > $octree";
102   die "Could not compile scene\n" if ( $? );
103 < # Set up sampling of interior portal
103 > # Output XML prologue
104 > print
105 > '<?xml version="1.0" encoding="UTF-8"?>
106 > <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 > ';
108 > print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 > print
110 > '<WindowElementType>System</WindowElementType>
111 > <FileType>BSDF</FileType>
112 > <Optical>
113 > <Layer>
114 >        <Material>
115 >                <Name>Name</Name>
116 >                <Manufacturer>Manufacturer</Manufacturer>
117 > ';
118 > printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 > printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 > printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 > print "\t\t<DeviceType>Other</DeviceType>\n";
122 > print " </Material>\n";
123 > # Output MGF description if requested
124 > if ( $geout ) {
125 >        print "\t<Geometry format=\"MGF\">\n";
126 >        print "\t\t<MGFblock unit=\"$gunit\">\n";
127 >        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
128 >        open(MGFSCN, "< $mgfscn");
129 >        while (<MGFSCN>) { print $_; }
130 >        close MGFSCN;
131 >        print "xf\n";
132 >        print "</MGFblock>\n";
133 >        print "\t</Geometry>\n";
134 > }
135 > # Set up surface sampling
136 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
137 > my $ny = int($nsamp/$nx + .5);
138 > $nsamp = $nx * $ny;
139 > my $ns = 2**$ttlog2;
140 > my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
141 > # Create data segments (all the work happens here)
142 > if ( $tensortree ) {
143 >        do_tree_bsdf();
144 > } else {
145 >        do_matrix_bsdf();
146 > }
147 > # Output XML epilogue
148 > print
149 > '</Layer>
150 > </Optical>
151 > </WindowElement>
152 > ';
153 > # Clean up temporary files and exit
154 > exec("rm -rf $td");
155 >
156 > #-------------- End of main program segment --------------#
157 >
158 > #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
159 > sub do_tree_bsdf {
160 > # Shirley-Chiu mapping from unit square to disk
161 > $sq2disk = '
162 > in_square_a = 2*in_square_x - 1;
163 > in_square_b = 2*in_square_y - 1;
164 > in_square_rgn = if(in_square_a + in_square_b,
165 >                        if(in_square_a - in_square_b, 1, 2),
166 >                        if(in_square_b - in_square_a, 3, 4));
167 > out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
168 >                        -in_square_a, -in_square_b);
169 > out_disk_phi = PI/4 * select(in_square_rgn,
170 >                                in_square_b/in_square_a,
171 >                                2 - in_square_a/in_square_b,
172 >                                4 + in_square_b/in_square_a,
173 >                                if(in_square_b*in_square_b,
174 >                                        6 - in_square_a/in_square_b, 0));
175 > Dx = out_disk_r*cos(out_disk_phi);
176 > Dy = out_disk_r*sin(out_disk_phi);
177 > Dz = sqrt(1 - out_disk_r*out_disk_r);
178 > ';
179 > # Shirley-Chiu mapping from unit disk to square
180 > $disk2sq = '
181 > norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
182 > in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
183 > in_disk_phi = norm_radians(atan2(Dy, Dx));
184 > in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
185 > out_square_a = select(in_disk_rgn,
186 >                        in_disk_r,
187 >                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
188 >                        -in_disk_r,
189 >                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
190 > out_square_b = select(in_disk_rgn,
191 >                        in_disk_phi*in_disk_r/(PI/4),
192 >                        in_disk_r,
193 >                        (PI - in_disk_phi)*in_disk_r/(PI/4),
194 >                        -in_disk_r);
195 > out_square_x = (out_square_a + 1)/2;
196 > out_square_y = (out_square_b + 1)/2;
197 > ';
198 > # Announce ourselves in XML output
199 > print "\t<DataDefinition>\n";
200 > print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
201 > print "\t</DataDefinition>\n";
202 >
203 > # Start rcontrib processes for compute each side
204 > do_tree_rtcontrib(0) if ( $doback );
205 > do_tree_rtcontrib(1) if ( $doforw );
206 >
207 > }       # end of sub do_tree_bsdf()
208 >
209 > # Run rcontrib process to generate tensor tree samples
210 > sub do_tree_rtcontrib {
211 >        my $forw = shift;
212 >        my $matargs = "-m $bmodnm";
213 >        if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
214 >        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
215 >                "-e '$disk2sq' -bn '$ns*$ns' " .
216 >                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
217 >                "-o $td/%s.flt $matargs $octree";
218 >        if ( $tensortree == 3 ) {
219 >                # Isotropic BSDF
220 >                my $ns2 = $ns / 2;
221 >                $cmd = "cnt $ns2 $ny $nx " .
222 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
223 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
224 >                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
225 >                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
226 >                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
227 >                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
228 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
229 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
230 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
231 >                        "| $cmd";
232 >        } else {
233 >                # Anisotropic BSDF
234 >                # Sample area vertically to improve load balance, since
235 >                # shading systems usually have bilateral symmetry (L-R)
236 >                $cmd = "cnt $ns $ns $ny $nx " .
237 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
238 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
239 >                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
240 >                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
241 >                        "-e 'in_square_x=(\$1+r1)/$ns' " .
242 >                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
243 >                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
244 >                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
245 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
246 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
247 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
248 >                        "| $cmd";
249 >        }
250 > # print STDERR "Starting: $cmd\n";
251 >        system "$cmd" || die "Failure running rcontrib";
252 >        ttree_out($forw);
253 > }       # end of do_tree_rtcontrib()
254 >
255 > # Simplify and output tensor tree results
256 > sub ttree_out {
257 >        my $forw = shift;
258 >        my $side = ("Back","Front")[$forw];
259 >        my $cmd;
260 > # Only output one transmitted anisotropic distribution, preferring backwards
261 > if ( !$forw || !$doback || $tensortree==3 ) {
262 > print
263 > '       <WavelengthData>
264 >                <LayerNumber>System</LayerNumber>
265 >                <Wavelength unit="Integral">Visible</Wavelength>
266 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
267 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
268 >                <WavelengthDataBlock>
269 > ';
270 > print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
271 > print
272 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
273 >                        <ScatteringDataType>BTDF</ScatteringDataType>
274 >                        <ScatteringData>
275 > ';
276 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
277 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
278 > if ($pctcull >= 0) {
279 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
280 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
281 >        system "$cmd" || die "Failure running rttree_reduce";
282 > } else {
283 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
284 >        print "{\n";
285 >        system "$cmd" || die "Failure running rcalc";
286 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
287 >                print "0\n";
288 >        }
289 >        print "}\n";
290 > }
291 > print
292 > '                       </ScatteringData>
293 >                </WavelengthDataBlock>
294 >        </WavelengthData>
295 > ';
296 > }
297 > # Output reflection
298 > print
299 > '       <WavelengthData>
300 >                <LayerNumber>System</LayerNumber>
301 >                <Wavelength unit="Integral">Visible</Wavelength>
302 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
303 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
304 >                <WavelengthDataBlock>
305 > ';
306 > print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
307 > print
308 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
309 >                        <ScatteringDataType>BTDF</ScatteringDataType>
310 >                        <ScatteringData>
311 > ';
312 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
313 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
314 > if ($pctcull >= 0) {
315 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
316 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
317 >        system "$cmd" || die "Failure running rttree_reduce";
318 > } else {
319 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
320 >        print "{\n";
321 >        system "$cmd" || die "Failure running rcalc";
322 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
323 >                print "0\n";
324 >        }
325 >        print "}\n";
326 > }
327 > print
328 > '                       </ScatteringData>
329 >                </WavelengthDataBlock>
330 >        </WavelengthData>
331 > ';
332 > }       # end of ttree_out()
333 >
334 > #------------- End of do_tree_bsdf() & subroutines -------------#
335 >
336 > #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
337 > sub do_matrix_bsdf {
338 > # Set up sampling of portal
339   # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
340 < my $tcal = '
340 > $tcal = '
341   DEGREE : PI/180;
342   sq(x) : x*x;
343 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
343 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
344   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
345   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
346   Kmax : Kaccum(Knaz(0));
# Line 104 | Line 358 | KprojOmega = PI * if(Kbin-.5,
358          1 - sq(cos(Kpola(1)*DEGREE)));
359   ';
360   # Compute Klems bin from exiting ray direction (forward or backward)
361 < my $kcal = '
361 > $kcal = '
362   DEGREE : PI/180;
363   abs(x) : if(x, x, -x);
364 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
364 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
365   posangle(a) : if(-a, a + 2*PI, a);
366 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
366 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
367   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
368   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
369   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 130 | Line 384 | kbin2(pol,azi) = select(kfindrow(1, pol),
384   kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
385   ';
386   my $ndiv = 145;
387 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
134 < my $ny = int($nsamp/$nx + .5);
135 < $nsamp = $nx * $ny;
136 < # Compute scattering data using rtcontrib
387 > # Compute scattering data using rcontrib
388   my @tfarr;
389   my @rfarr;
390   my @tbarr;
391   my @rbarr;
392   my $cmd;
393 < my $rtcmd = "rtcontrib -h -ff -fo -n $nproc -c $nsamp " .
393 > my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
394          "-e '$kcal' -b kbin -bn $ndiv " .
395 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $rtargs $octree";
395 >        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
396   my $rccmd = "rcalc -e '$tcal' " .
397          "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
398 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
398 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
399   if ( $doforw ) {
400   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
401          "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
# Line 156 | Line 407 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
407   system "$cmd" || die "Failure running: $cmd\n";
408   @tfarr = `$rccmd $td/$fmodnm.flt`;
409   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
410 + chomp(@tfarr);
411   @rfarr = `$rccmd $td/$bmodnm.flt`;
412   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
413 + chomp(@rfarr);
414   }
415   if ( $doback ) {
416   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
# Line 170 | Line 423 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
423   system "$cmd" || die "Failure running: $cmd\n";
424   @tbarr = `$rccmd $td/$bmodnm.flt`;
425   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
426 + chomp(@tbarr);
427   @rbarr = `$rccmd $td/$fmodnm.flt`;
428   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
429 + chomp(@rbarr);
430   }
431 < # Output XML prologue
431 > # Output angle basis
432   print
433 < '<?xml version="1.0" encoding="UTF-8"?>
434 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
435 <        <WindowElementType>System</WindowElementType>
181 <        <Optical>
182 <                <Layer>
183 <                <Material>
184 <                        <Name>Name</Name>
185 <                        <Manufacturer>Manufacturer</Manufacturer>
186 < ';
187 < printf "\t\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
188 < printf "\t\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
189 < printf "\t\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
190 < print "\t\t\t<DeviceType>Integral</DeviceType>\n";
191 < # Output MGF description if requested
192 < if ( $geout ) {
193 <        print "\t\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
194 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
195 <        system "cat $mgfscn";
196 <        print "xf\n";
197 <        print "\t\t\t</Geometry>\n";
198 < }
199 < print '                 </Material>
200 <                <DataDefinition>
201 <                        <IncidentDataStructure>Columns</IncidentDataStructure>
202 <                        <AngleBasis>
433 > '       <DataDefinition>
434 >                <IncidentDataStructure>Columns</IncidentDataStructure>
435 >                <AngleBasis>
436                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
437 <                                <AngleBasisBlock>
438 <                                <Theta>0</Theta>
439 <                                <nPhis>1</nPhis>
440 <                                <ThetaBounds>
437 >                        <AngleBasisBlock>
438 >                        <Theta>0</Theta>
439 >                        <nPhis>1</nPhis>
440 >                        <ThetaBounds>
441                                  <LowerTheta>0</LowerTheta>
442                                  <UpperTheta>5</UpperTheta>
443 <                                </ThetaBounds>
211 <                                </AngleBasisBlock>
212 <                                <AngleBasisBlock>
213 <                                <Theta>10</Theta>
214 <                                <nPhis>8</nPhis>
215 <                                <ThetaBounds>
216 <                                        <LowerTheta>5</LowerTheta>
217 <                                        <UpperTheta>15</UpperTheta>
218 <                                </ThetaBounds>
219 <                                </AngleBasisBlock>
220 <                                <AngleBasisBlock>
221 <                                <Theta>20</Theta>
222 <                                <nPhis>16</nPhis>
223 <                                <ThetaBounds>
224 <                                        <LowerTheta>15</LowerTheta>
225 <                                        <UpperTheta>25</UpperTheta>
226 <                                </ThetaBounds>
227 <                                </AngleBasisBlock>
228 <                                <AngleBasisBlock>
229 <                                <Theta>30</Theta>
230 <                                <nPhis>20</nPhis>
231 <                                <ThetaBounds>
232 <                                        <LowerTheta>25</LowerTheta>
233 <                                        <UpperTheta>35</UpperTheta>
234 <                                </ThetaBounds>
235 <                                </AngleBasisBlock>
236 <                                <AngleBasisBlock>
237 <                                <Theta>40</Theta>
238 <                                <nPhis>24</nPhis>
239 <                                <ThetaBounds>
240 <                                        <LowerTheta>35</LowerTheta>
241 <                                        <UpperTheta>45</UpperTheta>
242 <                                </ThetaBounds>
243 <                                </AngleBasisBlock>
244 <                                <AngleBasisBlock>
245 <                                <Theta>50</Theta>
246 <                                <nPhis>24</nPhis>
247 <                                <ThetaBounds>
248 <                                        <LowerTheta>45</LowerTheta>
249 <                                        <UpperTheta>55</UpperTheta>
250 <                                </ThetaBounds>
251 <                                </AngleBasisBlock>
252 <                                <AngleBasisBlock>
253 <                                <Theta>60</Theta>
254 <                                <nPhis>24</nPhis>
255 <                                <ThetaBounds>
256 <                                        <LowerTheta>55</LowerTheta>
257 <                                        <UpperTheta>65</UpperTheta>
258 <                                </ThetaBounds>
259 <                                </AngleBasisBlock>
260 <                                <AngleBasisBlock>
261 <                                <Theta>70</Theta>
262 <                                <nPhis>16</nPhis>
263 <                                <ThetaBounds>
264 <                                        <LowerTheta>65</LowerTheta>
265 <                                        <UpperTheta>75</UpperTheta>
266 <                                </ThetaBounds>
267 <                                </AngleBasisBlock>
268 <                                <AngleBasisBlock>
269 <                                <Theta>82.5</Theta>
270 <                                <nPhis>12</nPhis>
271 <                                <ThetaBounds>
272 <                                        <LowerTheta>75</LowerTheta>
273 <                                        <UpperTheta>90</UpperTheta>
274 <                                </ThetaBounds>
443 >                        </ThetaBounds>
444                          </AngleBasisBlock>
445 +                        <AngleBasisBlock>
446 +                        <Theta>10</Theta>
447 +                        <nPhis>8</nPhis>
448 +                        <ThetaBounds>
449 +                                <LowerTheta>5</LowerTheta>
450 +                                <UpperTheta>15</UpperTheta>
451 +                        </ThetaBounds>
452 +                        </AngleBasisBlock>
453 +                        <AngleBasisBlock>
454 +                        <Theta>20</Theta>
455 +                        <nPhis>16</nPhis>
456 +                        <ThetaBounds>
457 +                                <LowerTheta>15</LowerTheta>
458 +                                <UpperTheta>25</UpperTheta>
459 +                        </ThetaBounds>
460 +                        </AngleBasisBlock>
461 +                        <AngleBasisBlock>
462 +                        <Theta>30</Theta>
463 +                        <nPhis>20</nPhis>
464 +                        <ThetaBounds>
465 +                                <LowerTheta>25</LowerTheta>
466 +                                <UpperTheta>35</UpperTheta>
467 +                        </ThetaBounds>
468 +                        </AngleBasisBlock>
469 +                        <AngleBasisBlock>
470 +                        <Theta>40</Theta>
471 +                        <nPhis>24</nPhis>
472 +                        <ThetaBounds>
473 +                                <LowerTheta>35</LowerTheta>
474 +                                <UpperTheta>45</UpperTheta>
475 +                        </ThetaBounds>
476 +                        </AngleBasisBlock>
477 +                        <AngleBasisBlock>
478 +                        <Theta>50</Theta>
479 +                        <nPhis>24</nPhis>
480 +                        <ThetaBounds>
481 +                                <LowerTheta>45</LowerTheta>
482 +                                <UpperTheta>55</UpperTheta>
483 +                        </ThetaBounds>
484 +                        </AngleBasisBlock>
485 +                        <AngleBasisBlock>
486 +                        <Theta>60</Theta>
487 +                        <nPhis>24</nPhis>
488 +                        <ThetaBounds>
489 +                                <LowerTheta>55</LowerTheta>
490 +                                <UpperTheta>65</UpperTheta>
491 +                        </ThetaBounds>
492 +                        </AngleBasisBlock>
493 +                        <AngleBasisBlock>
494 +                        <Theta>70</Theta>
495 +                        <nPhis>16</nPhis>
496 +                        <ThetaBounds>
497 +                                <LowerTheta>65</LowerTheta>
498 +                                <UpperTheta>75</UpperTheta>
499 +                        </ThetaBounds>
500 +                        </AngleBasisBlock>
501 +                        <AngleBasisBlock>
502 +                        <Theta>82.5</Theta>
503 +                        <nPhis>12</nPhis>
504 +                        <ThetaBounds>
505 +                                <LowerTheta>75</LowerTheta>
506 +                                <UpperTheta>90</UpperTheta>
507 +                        </ThetaBounds>
508 +                        </AngleBasisBlock>
509                  </AngleBasis>
510          </DataDefinition>
511   ';
512   if ( $doforw ) {
513 < print '         <WavelengthData>
513 > print
514 > '       <WavelengthData>
515                  <LayerNumber>System</LayerNumber>
516                  <Wavelength unit="Integral">Visible</Wavelength>
517                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
# Line 292 | Line 526 | print '                <WavelengthData>
526   # Output front transmission (transposed order)
527   for (my $od = 0; $od < $ndiv; $od++) {
528          for (my $id = 0; $id < $ndiv; $id++) {
529 <                print $tfarr[$ndiv*$id + $od];
529 >                print $tfarr[$ndiv*$id + $od], ",\n";
530          }
531          print "\n";
532   }
533   print
534 < '               </ScatteringData>
535 <        </WavelengthDataBlock>
534 > '                       </ScatteringData>
535 >                </WavelengthDataBlock>
536          </WavelengthData>
537          <WavelengthData>
538                  <LayerNumber>System</LayerNumber>
# Line 309 | Line 543 | print
543                          <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
544                          <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
545                          <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
546 <                        <ScatteringDataType>BRDF</ScatteringDataType>
546 >                        <ScatteringDataType>BTDF</ScatteringDataType>
547                          <ScatteringData>
548   ';
549   # Output front reflection (transposed order)
550   for (my $od = 0; $od < $ndiv; $od++) {
551          for (my $id = 0; $id < $ndiv; $id++) {
552 <                print $rfarr[$ndiv*$id + $od];
552 >                print $rfarr[$ndiv*$id + $od], ",\n";
553          }
554          print "\n";
555   }
556   print
557 < '               </ScatteringData>
558 <        </WavelengthDataBlock>
557 > '                       </ScatteringData>
558 >                </WavelengthDataBlock>
559          </WavelengthData>
560   ';
561   }
562   if ( $doback ) {
563 < print '         <WavelengthData>
563 > print
564 > '       <WavelengthData>
565                  <LayerNumber>System</LayerNumber>
566                  <Wavelength unit="Integral">Visible</Wavelength>
567                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
# Line 341 | Line 576 | print '                <WavelengthData>
576   # Output back transmission (transposed order)
577   for (my $od = 0; $od < $ndiv; $od++) {
578          for (my $id = 0; $id < $ndiv; $id++) {
579 <                print $tbarr[$ndiv*$id + $od];
579 >                print $tbarr[$ndiv*$id + $od], ",\n";
580          }
581          print "\n";
582   }
583   print
584 < '               </ScatteringData>
585 <        </WavelengthDataBlock>
584 > '                       </ScatteringData>
585 >                </WavelengthDataBlock>
586          </WavelengthData>
587          <WavelengthData>
588                  <LayerNumber>System</LayerNumber>
# Line 358 | Line 593 | print
593                          <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
594                          <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
595                          <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
596 <                        <ScatteringDataType>BRDF</ScatteringDataType>
596 >                        <ScatteringDataType>BTDF</ScatteringDataType>
597                          <ScatteringData>
598   ';
599   # Output back reflection (transposed order)
600   for (my $od = 0; $od < $ndiv; $od++) {
601          for (my $id = 0; $id < $ndiv; $id++) {
602 <                print $rbarr[$ndiv*$id + $od];
602 >                print $rbarr[$ndiv*$id + $od], ",\n";
603          }
604          print "\n";
605   }
606   print
607 < '               </ScatteringData>
608 <        </WavelengthDataBlock>
607 > '                       </ScatteringData>
608 >                </WavelengthDataBlock>
609          </WavelengthData>
610   ';
611   }
612 < # Output XML epilogue
613 < print '</Layer>
379 < </Optical>
380 < </WindowElement>
381 < ';
382 < # Clean up temporary files
383 < system "rm -rf $td";
612 > }
613 > #------------- End of do_matrix_bsdf() --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines